# LICENSE:
#
# (The MIT License)
#
# Copyright © 2008 Tom Preston-Werner
#
# Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

require 'numerizer/version'
require 'providers/english_provider'
require 'set'

class Numerizer

  PROVIDERS = {'en' => EnglishProvider.new}

  def self.numerize(string,lang: 'en', ignore: [], bias: :none)
    string = string.dup
    ignore = ignore.map(&:downcase).to_set
    provider = PROVIDERS[lang]
    if provider == nil
      raise "Language #{lang} not found. Language options include #{PROVIDERS.keys}"
    end
    provider.numerize(string, ignore: ignore, bias: bias)
  end

end
